import * as React from "react";
declare type ReactElement = React.ReactElement;
export declare type MatchFunc<S> = (value: any, state?: S) => boolean;
export declare type ReplacerFunc<S> = (value: any, state?: S) => ReactElement;
export declare type StateUpdateFunc<S> = (input: any, state?: S) => S;
export declare type ReplacerSharedProps<StateType = any> = {
    replace: ReplacerFunc<StateType>;
    updateState?: StateUpdateFunc<StateType>;
    initialState?: StateType;
};
export declare type ReplacerProps<StateType = any> = ReplacerSharedProps<StateType> & ({
    match: MatchFunc<StateType>;
} | {
    matchElement: React.ComponentType | string;
} | {
    matchLiteral: MatchFunc<StateType>;
});
declare function Replacer<StateType = any>(props: React.PropsWithChildren<ReplacerProps<StateType>>): React.ReactElement;
export { Replacer };
